#!/usr/local/bin/bash
# Author : Sepp Wang ( pennywang.tw @ yahoo.com.tw )
# Date : 2007/03/27
# Purpose : Start the SIP Fluoroscope at system startup
#SIPFLUOROSCOPE=`/home/martensite/www/sipmagnifier/captor.exe | /home/martensite/www/sipmagnifier/dissector_lite.php &`
DISSECTOR_PID_FILE='/var/run/sipfluoroscope.pid'
DISSECTOR_PID=$(cat $DISSECTOR_PID_FILE)
CAPTOR_PID=$(($DISSECTOR_PID-1))
function USAGE() {
echo "Usage : $0 [start|stop|restart]"
}
# ---- Main ------
if [ X$# == X0 ]; then
   /home/martensite/www/sipmagnifier/captor.exe | /home/martensite/www/sipmagnifier/dissector_lite.php &
   echo $! > /var/run/sipfluoroscope.pid
elif [ X$# == X1 ]; then
	case $1 in
	start)
		echo "Starting SIP Fluoroscope ..."
		/home/martensite/www/sipmagnifier/captor.exe | /home/martensite/www/sipmagnifier/dissector_lite.php &
		echo $! > /var/run/sipfluoroscope.pid
		echo "Done."
		;;
	stop)
		echo "Stoping SIP Fluoroscope ..."
		kill $DISSECTOR_PID
		kill $CAPTOR_PID
		echo "Done."
		;;
	restart)
		echo "Restarting SIP Fluoroscope ..."
		kill $DISSECTOR_PID
		kill $CAPTOR_PID
		/home/martensite/www/sipmagnifier/captor.exe | /home/martensite/www/sipmagnifier/dissector_lite.php &
		echo $! > /var/run/sipfluoroscope.pid
		echo "Done."
		;;
	*)
		USAGE
		;;
	esac
else
	USAGE
fi
